var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  cursor: () => import_language_common2.cursor,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  dateFns: () => import_language_common2.dateFns,
  default: () => src_default,
  each: () => import_language_common2.each,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  get: () => get,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  post: () => post,
  request: () => request2,
  sourceValue: () => import_language_common2.sourceValue
});
module.exports = __toCommonJS(src_exports);

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  cursor: () => import_language_common2.cursor,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  dateFns: () => import_language_common2.dateFns,
  each: () => import_language_common2.each,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  get: () => get,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  post: () => post,
  request: () => request2,
  sourceValue: () => import_language_common2.sourceValue
});
var import_util2 = require("@openfn/language-common/util");

// src/Utils.js
var import_language_common = require("@openfn/language-common");
var import_util = require("@openfn/language-common/util");
var import_node_path = __toESM(require("path"), 1);
var cookie;
var prepareNextState = (state, response) => {
  const { body, ...responseWithoutBody } = response;
  if (!state.references) {
    state.references = [];
  }
  return {
    ...(0, import_language_common.composeNextState)(state, response.body),
    response: responseWithoutBody
  };
};
var authenticate = async (opts) => {
  const response = await (0, import_util.request)("POST", "/login", opts);
  return response.headers["set-cookie"].split(";")[0];
};
var request = async (state, method, path, options = {}) => {
  var _a;
  const { baseUrl, username, password } = state.configuration;
  let headers = { "Cookie": cookie || ((_a = options.headers) == null ? void 0 : _a.Cookie) };
  const errors = { 404: "Page not found" };
  let opts = {
    parseAs: "json",
    errors,
    baseUrl,
    ...options,
    headers: {
      "content-type": "application/json",
      ...headers
    }
  };
  const safePath = import_node_path.default.join(path);
  if (!opts.headers.Cookie && username && password) {
    cookie = await authenticate({ ...opts, parseAs: "text/html", body: { username, password } });
    opts = { ...opts, headers: { ...opts.headers, Cookie: cookie } };
  }
  return (0, import_util.request)(method, safePath, opts);
};

// src/Adaptor.js
var import_language_common2 = require("@openfn/language-common");
function get(path, options) {
  return async (state) => {
    const response = await request(state, "GET", path, options);
    return prepareNextState(state, response);
  };
}
function post(path, body, options) {
  return async (state) => {
    const response = await request(state, "POST", path, { ...options, body });
    return prepareNextState(state, response);
  };
}
function request2(method, path, options = {}) {
  return async (state) => {
    const [resolvedMethod, resolvedPath, resolvedoptions] = (0, import_util2.expandReferences)(state, method, path, options);
    const response = await request(
      state,
      resolvedMethod,
      resolvedPath,
      resolvedoptions
    );
    return prepareNextState(state, response);
  };
}

// src/index.js
var src_default = Adaptor_exports;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  cursor,
  dataPath,
  dataValue,
  dateFns,
  each,
  field,
  fields,
  fn,
  get,
  lastReferenceValue,
  merge,
  post,
  request,
  sourceValue
});
