var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  cursor: () => cursor,
  dataPath: () => dataPath,
  dataValue: () => dataValue,
  dateFns: () => dateFns,
  each: () => each,
  field: () => field,
  fields: () => fields,
  fn: () => fn,
  get: () => get,
  lastReferenceValue: () => lastReferenceValue,
  merge: () => merge,
  post: () => post,
  request: () => request2,
  sourceValue: () => sourceValue
});
import { expandReferences } from "@openfn/language-common/util";

// src/Utils.js
import { composeNextState } from "@openfn/language-common";
import { request as commonRequest } from "@openfn/language-common/util";
import nodepath from "path";
var cookie;
var prepareNextState = (state, response) => {
  const { body, ...responseWithoutBody } = response;
  if (!state.references) {
    state.references = [];
  }
  return {
    ...composeNextState(state, response.body),
    response: responseWithoutBody
  };
};
var authenticate = async (opts) => {
  const response = await commonRequest("POST", "/login", opts);
  return response.headers["set-cookie"].split(";")[0];
};
var request = async (state, method, path, options = {}) => {
  var _a;
  const { baseUrl, username, password } = state.configuration;
  let headers = { "Cookie": cookie || ((_a = options.headers) == null ? void 0 : _a.Cookie) };
  const errors = { 404: "Page not found" };
  let opts = {
    parseAs: "json",
    errors,
    baseUrl,
    ...options,
    headers: {
      "content-type": "application/json",
      ...headers
    }
  };
  const safePath = nodepath.join(path);
  if (!opts.headers.Cookie && username && password) {
    cookie = await authenticate({ ...opts, parseAs: "text/html", body: { username, password } });
    opts = { ...opts, headers: { ...opts.headers, Cookie: cookie } };
  }
  return commonRequest(method, safePath, opts);
};

// src/Adaptor.js
import {
  dataPath,
  dataValue,
  dateFns,
  cursor,
  each,
  field,
  fields,
  fn,
  lastReferenceValue,
  merge,
  sourceValue
} from "@openfn/language-common";
function get(path, options) {
  return async (state) => {
    const response = await request(state, "GET", path, options);
    return prepareNextState(state, response);
  };
}
function post(path, body, options) {
  return async (state) => {
    const response = await request(state, "POST", path, { ...options, body });
    return prepareNextState(state, response);
  };
}
function request2(method, path, options = {}) {
  return async (state) => {
    const [resolvedMethod, resolvedPath, resolvedoptions] = expandReferences(state, method, path, options);
    const response = await request(
      state,
      resolvedMethod,
      resolvedPath,
      resolvedoptions
    );
    return prepareNextState(state, response);
  };
}

// src/index.js
var src_default = Adaptor_exports;
export {
  cursor,
  dataPath,
  dataValue,
  dateFns,
  src_default as default,
  each,
  field,
  fields,
  fn,
  get,
  lastReferenceValue,
  merge,
  post,
  request2 as request,
  sourceValue
};
